diff --git a/cli/src/cli-cmd.c b/cli/src/cli-cmd.c
index ba01482b609..803a46b9501 100644
--- a/cli/src/cli-cmd.c
+++ b/cli/src/cli-cmd.c
@@ -31,7 +31,7 @@ int cli_op_ret = 0;
 static gf_boolean_t connected = _gf_false;
 
 static unsigned
-cli_cmd_needs_connection(struct cli_cmd_word *word)
+cli_cmd_needs_connection(struct cli_state *state, struct cli_cmd_word *word)
 {
     if (!strcasecmp("quit", word->word))
         return 0;
@@ -45,7 +45,7 @@ cli_cmd_needs_connection(struct cli_cmd_word *word)
     if (!strcasecmp("exit", word->word))
         return 0;
 
-    return cli_default_conn_timeout;
+    return state->default_conn_timeout;
 }
 
 int
@@ -118,7 +118,7 @@ cli_cmd_process(struct cli_state *state, int argc, char **argv)
     if (strcmp(word->word, "help") == 0)
         goto callback;
 
-    state->await_connected = cli_cmd_needs_connection(word);
+    state->await_connected = cli_cmd_needs_connection(state, word);
 
     ret = cli_cmd_await_connected(state->await_connected);
     if (ret) {
@@ -355,13 +355,14 @@ cli_cmd_submit(struct rpc_clnt *rpc, void *req, call_frame_t *frame,
 {
     int ret = -1;
     time_t timeout = 0;
+    struct cli_state *state = frame->this->private;
 
     if ((GLUSTER_CLI_PROFILE_VOLUME == procnum) ||
         (GLUSTER_CLI_HEAL_VOLUME == procnum) ||
         (GLUSTER_CLI_GANESHA == procnum))
-        timeout = cli_ten_minutes_timeout;
+        timeout = CLI_TEN_MINUTES_TIMEOUT;
     else
-        timeout = cli_default_conn_timeout;
+        timeout = state->default_conn_timeout;
 
     cli_cmd_lock();
     cmd_sent = 0;
diff --git a/cli/src/cli-rpc-ops.c b/cli/src/cli-rpc-ops.c
index 568b1ca4ecb..61cd3f59762 100644
--- a/cli/src/cli-rpc-ops.c
+++ b/cli/src/cli-rpc-ops.c
@@ -83,7 +83,7 @@ cli_to_glusterd(gf_cli_req *req, call_frame_t *frame, fop_cbk_fn_t cbkfn,
                 rpc_clnt_prog_t *prog, struct iobref *iobref);
 
 static int
-add_cli_cmd_timeout_to_dict(dict_t *dict);
+add_cli_cmd_timeout_to_dict(struct cli_state *state, dict_t *dict);
 
 static rpc_clnt_prog_t cli_handshake_prog = {
     .progname = "cli handshake",
@@ -3485,17 +3485,19 @@ cli_quotad_getlimit(call_frame_t *frame, xlator_t *this, void *data)
     int ret = 0;
     dict_t *dict = NULL;
     struct rpc_clnt *rpc = NULL;
+    struct cli_state *state = NULL;
 
     if (!frame || !this || !data) {
         ret = -1;
         goto out;
     }
 
-    rpc = ((cli_state_t *)(frame->this->private))->quotad_rpc;
+    state = frame->this->private;
+    rpc = state->quotad_rpc;
     GF_ASSERT(rpc);
 
     dict = data;
-    ret = add_cli_cmd_timeout_to_dict(dict);
+    ret = add_cli_cmd_timeout_to_dict(state, dict);
 
     ret = dict_allocate_and_serialize(dict, &req.dict.dict_val,
                                       &req.dict.dict_len);
@@ -10548,12 +10550,12 @@ gf_cli_get_vol_opt(call_frame_t *frame, xlator_t *this, void *data)
 }
 
 static int
-add_cli_cmd_timeout_to_dict(dict_t *dict)
+add_cli_cmd_timeout_to_dict(struct cli_state *state, dict_t *dict)
 {
     int ret = 0;
 
-    if (cli_default_conn_timeout > 120) {
-        ret = dict_set_time(dict, "timeout", cli_default_conn_timeout);
+    if (state->default_conn_timeout > 120) {
+        ret = dict_set_time(dict, "timeout", state->default_conn_timeout);
         if (ret) {
             gf_log("cli", GF_LOG_INFO, "Failed to save timeout to dict");
         }
@@ -10572,6 +10574,7 @@ cli_to_glusterd(gf_cli_req *req, call_frame_t *frame, fop_cbk_fn_t cbkfn,
     int i = 0;
     const char **words = NULL;
     cli_local_t *local = NULL;
+    struct cli_state *state = frame->this->private;
 
     if (!this || !frame || !frame->local || !dict) {
         ret = -1;
@@ -10607,7 +10610,7 @@ cli_to_glusterd(gf_cli_req *req, call_frame_t *frame, fop_cbk_fn_t cbkfn,
     if (ret)
         goto out;
 
-    ret = add_cli_cmd_timeout_to_dict(dict);
+    ret = add_cli_cmd_timeout_to_dict(state, dict);
 
     ret = dict_allocate_and_serialize(dict, &(req->dict).dict_val,
                                       &(req->dict).dict_len);
diff --git a/cli/src/cli.c b/cli/src/cli.c
index aba1825cc91..84804207907 100644
--- a/cli/src/cli.c
+++ b/cli/src/cli.c
@@ -74,9 +74,6 @@ rpc_clnt_prog_t *cli_rpc_prog;
 
 extern struct rpc_clnt_program cli_prog;
 
-time_t cli_default_conn_timeout = 120;
-time_t cli_ten_minutes_timeout = 600;
-
 static int
 glusterfs_ctx_defaults_init(glusterfs_ctx_t *ctx)
 {
@@ -440,7 +437,7 @@ cli_opt_parse(char *opt, struct cli_state *state)
             /* Use -2 to not confuse with unknown option error. */
             return -2;
         }
-        cli_default_conn_timeout = val;
+        state->default_conn_timeout = val;
         return 0;
     }
 
@@ -545,6 +542,8 @@ cli_state_init(struct cli_state *state)
     struct cli_cmd_tree *tree = NULL;
     int ret = 0;
 
+    state->default_conn_timeout = CLI_DEFAULT_CONN_TIMEOUT;
+
     state->log_level = GF_LOG_NONE;
 
     tree = &state->tree;
@@ -807,9 +806,6 @@ main(int argc, char *argv[])
     if (ret)
         goto out;
 
-    cli_default_conn_timeout = 120;
-    cli_ten_minutes_timeout = 600;
-
     ret = cli_state_init(&state);
     if (ret)
         goto out;
diff --git a/cli/src/cli.h b/cli/src/cli.h
index 7392c948173..76b89f4e2c0 100644
--- a/cli/src/cli.h
+++ b/cli/src/cli.h
@@ -38,14 +38,18 @@
 #define GEO_REP_CMD_INDEX 1
 #define GEO_REP_CMD_CONFIG_INDEX 4
 
+/* Default RPC call timeout, in seconds. */
+#define CLI_DEFAULT_CONN_TIMEOUT 120
+
+/* Special timeout for volume profile, volume
+   heal and ganesha RPC calls, in seconds. */
+#define CLI_TEN_MINUTES_TIMEOUT 600
+
 enum argp_option_keys {
     ARGP_DEBUG_KEY = 133,
     ARGP_PORT_KEY = 'p',
 };
 
-extern time_t cli_default_conn_timeout;
-extern time_t cli_ten_minutes_timeout;
-
 typedef enum {
     COLD_BRICK_COUNT,
     COLD_TYPE,
@@ -143,6 +147,8 @@ struct cli_state {
     int mode;
     int await_connected;
 
+    time_t default_conn_timeout;
+
     char *log_file;
     gf_loglevel_t log_level;
 
